#!/bin/bash
########################################################################
MY_PATH="`dirname \"$0\"`"              # relative
MY_PATH="`( cd \"$MY_PATH\" && pwd )`"  # absolutized and normalized
ME="${0##*/}"
echo '
########################################################################
# \\///
# qo-op
############# '$MY_PATH/$ME'
########################################################################
# Make a G1SSB Account
########################################################################
'
if [[ -d ~/.ssb ]]; then
    echo "ScuttelButt is already installed..."
    echo "Do you want to remove ~/.ssb ? (y)/n"
    read isitok
    if [[ "$isitok" == "y" ]]; then rm -Rf ~/.ssb; else echo "You must remove '~/.ssb' before running $ME"; exit 1; fi
fi

mkdir -p ~/.ssb    
echo "WELCOME CREATING YOUR G1 SSB ACCOUNT !!!"
echo '
 __     __  __  _  
/__ /| (_  (_  |_) 
\_|  | __) __) |_) 
                   
CHOOSE YOU LOGIN or LEAVE BLANK & HIT ENTER FOR AUTO GENERATION
'
read salt
[[ $salt != "" ]] && echo "CHOOSE PASSWORD?" && read pepper && [[ $pepper == "" ]] && exit 1

if [[ "$salt" == "" && "$pepper" == "" ]]; then
    echo '                                     
._ _  ._   _  ._ _   _  ._  o  _ 
| | | | | (/_ | | | (_) | | | (_ 

passphrase generator...'

    # GENERATE MNEMONIC KEY: 9 MOTS
    # LOGIN (=SALT) 6 WORDS
    salt="$($MY_PATH/diceware.sh 6)"
    # PASS (=PEPPER) 3 WORDS
    pepper="$($MY_PATH/diceware.sh 3)"

    echo "........."
    echo "REMEMBER YOUR CREDENTIALS !!!
login (salt)    : $salt
password        : $pepper"

fi

# CREATE ~/.ssb/secret.dunikey
python3 $MY_PATH/key_create_dunikey.py "$salt" "$pepper"
mv $MY_PATH/.secret.dunikey ~/.ssb/secret.dunikey

# CREATE SSB secret
pub=$(cat ~/.ssb/secret.dunikey | grep "pub" | cut -d ' ' -f 2)
priv=$(cat ~/.ssb/secret.dunikey | grep "sec" | cut -d ' ' -f 2)
ssbpub=$(echo $pub | base58 -d | base64)
ssbpriv=$(echo $priv | base58 -d | base64)

cat > ~/.ssb/secret <<EOF
# This secret is related to your G1Wallet - https://cesium.app
# silkaj balance $pub
# ID (salt): $salt / Pass: $pepper
# THIS KEY IS YOURS! REMIND IT AND KEEP IT SAFE AS A REAL WALLET
# chmod 400 ~/.zen/secret

{
  "curve": "ed25519",
  "public": "$ssbpub.ed25519",
  "private": "$ssbpriv.ed25519",
  "id": "@$ssbpub.ed25519"
}

# WARNING! It's vital that you DO NOT edit OR share your secret name
# instead, share your public name
# your SSB public name: @$ssbpub.ed25519
EOF

echo "
 _                      
|__|_  \  /  _  o |  _. 
|_ |_   \/  (_) | | (_| 

Your G1SSB KEY is made !!

# Social App
Install Patchwork : https://github.com/ssbc/patchwork/releases/

# Libre Money Wallet
Use your credential with https://cesium.app
login (salt)    : $salt
password        : $pepper
"

exit 0
